package org.artifactory.metrics.framework;

/**
 * Holds all feature adoption actions that are tracked as part of Feature Adoption.
 *
 * @author Oleksandr Legenkiy
 */
public enum FeatureAdoptionActions {

    CREATE_ARCHIVING_POLICY_API_ADMIN("create_archiving_policy_api_admin"),
    CREATE_ARCHIVING_POLICY_UI_ADMIN("create_archiving_policy_ui_admin"),
    VISIT_ARCHIVING_POLICY_LIST_PAGE_ADMIN("visit_archiving_policy_list_page_admin"),
    RESOURCE_ARCHIVED_VIA_ARCHIVING_POLICY("resource_archived_via_archiving_policy"),
    ;

    private final String action;

    FeatureAdoptionActions(String action) {
        this.action = action;
    }

    public String action() {
        return action;
    }
}
