package org.artifactory.metrics.framework;

import org.artifactory.spring.ReloadableBean;
import org.jfrog.metrics.model.TrackingSchema;

/**
 * A service to perform Feature Adoption (aka Usage Metrics) tracking operations.
 *
 * @author Oleksandr Legenkiy
 */
public interface FeatureAdoptionService extends ReloadableBean {

    /**
     * This is a basic method that should be used to track usage of features as part of Feature Adoption.
     *
     * @param feature a feature that should be tracked
     * @param action  an action that should be tracked
     * @param success <code>true</code> if a tracked action was successful, otherwise <code>false</code>.
     */
    void trackAdoption(FeatureAdoptionFeatures feature, FeatureAdoptionActions action, boolean success);

    void trackIncrease(TrackingSchema trackingSample);

    void trackDecrease(TrackingSchema trackingSample);

    void trackAverage(TrackingSchema trackingSample);

    void trackSet(TrackingSchema trackingSample);

    void trackUnset(TrackingSchema trackingSample);
}
