package org.artifactory.schedule;

import org.artifactory.api.context.ContextHelper;
import org.artifactory.common.home.ArtifactoryHome;
import org.artifactory.storage.db.locks.service.DbLocksService;
import org.jfrog.common.concurrency.ConflictsGuard;
import org.quartz.JobDetail;
import org.quartz.Trigger;

/**
 * @author Mor Merhav
 */
public final class TaskFactory {

    private TaskFactory() {
    }

    static Task createQuartzTask(Class<? extends TaskCallback> command, Trigger trigger,
                                 JobDetail jobDetail) {
        if (ArtifactoryHome.get().isHaConfigured()) {
            ConflictsGuard<String> conflictsGuard =
                    ContextHelper.get().beanForType(TaskService.class).getConflictsGuard();
            DbLocksService dbLocksService = ContextHelper.get().beanForType(DbLocksService.class);
            return new HaQuartzTask(new QuartzTask(command, trigger, jobDetail), conflictsGuard, dbLocksService);
        }
        return new QuartzTask(command, trigger, jobDetail);
    }

}
