package org.artifactory.rest.compression;

import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.HttpHeaders;
import javax.ws.rs.ext.Provider;
import javax.ws.rs.ext.WriterInterceptor;
import javax.ws.rs.ext.WriterInterceptorContext;
import java.io.IOException;
import java.util.zip.GZIPOutputStream;

/**
 * Intercept and gzip the output of endpoints annotated with @Compress
 *
 * @author shaharz
 */
@Provider
@Compress
public class GZIPWriterInterceptor implements WriterInterceptor {

    @Override
    public void aroundWriteTo(WriterInterceptorContext context)
            throws IOException, WebApplicationException {
        context.getHeaders().add(HttpHeaders.CONTENT_ENCODING, "gzip");
        GZIPOutputStream gzipStream = new GZIPOutputStream(context.getOutputStream());
        context.setOutputStream(gzipStream);
        context.proceed();
    }
}
